//	This code copyright (c) by the Grail project.
//	No commercial use permitted without written consent. 
//	August 1994

#ifndef		ARRAY_CLASS_DEFINITION

#include	<iostream.h>
#include	<ctype.h>
#include	<stdlib.h>

template <class Item>
class array
{
	protected:

	Item*		p;			// array of Items
	int		max;			// maximum size
	int		sz;			// current size
	int		sorted;			// is the array sorted?

	static array<Item>*     pool;
        static int              pool_sz;
#ifndef	XLC
        static int              max_pool;
#endif

	public:
			array();
			array(int i);
			array(const array<Item>&);
			~array();
	array<Item>&	clear()				// clear contents
			{ sz = 0; sorted = 1; return *this; }
 	int		contain(const array<Item>&) const;// check containment
	int		is_sorted() const		// is array sorted?
			{ return sorted; }
	static	int	compare(const Item*, const Item*);
	int		member(const Item&) const;	// check membership
	int		allocated() const
			{ return max; }
	array<Item>&	operator=(const array<Item>&);
	array<Item>&	operator=(const Item&);	
	int		operator==(const array<Item>&) const;	
	int		operator!=(const array<Item>& l) const
			{ return *this == l ? 0 : 1; }
	array<Item>&	operator+=(const array<Item>&);	// array union
 	array<Item>&	operator+=(const Item&);	// add an Item 
 	array<Item>&	operator-=(const array<Item>&);	// array difference
 	array<Item>&	operator-=(const Item&);	// remove an Item 
 	int		operator<(const array<Item>&) const;
 	int		operator>(const array<Item>& s) const
			{ return s < *this ? 1 : 0; }
 	array<Item>&	remove(int i);			// remove ith Item
 	void		merge(const array<Item>&);	// merge sorted arrays
	Item&		operator[](int i) const		// return ith Item
			{ return p[i]; }
	int		size() const			// return size
			{ return sz; }
	void		sort() const;			// sort elements 
	void		swap(array<Item>& a)
			{ int tmp = a.max; a.max = max; max = tmp;
			  tmp = a.sorted; a.sorted = sorted; sorted = tmp;
			  tmp = a.sz; a.sz = sz; sz = tmp;
			  Item* ptr = a.p; a.p = p; p =ptr; }
	array<Item>&	unique();			// remove duplicates
	void		unsorted()			// set unsortedness
			{ sorted = 0; }

	private:

	void		pool_extract(const int);
};

#define	ARRAY_CLASS_DEFINITION
#endif
