//	This code copyright (c) by the Grail project
//	No commercial use permitted without written consent.
//	June 1995

#ifndef	BITS_CLASS_DEFINITION

class bits 
{
	friend ostream& 
	operator<<(ostream&, const bits&);

	private:

		unsigned int*	b;		// bits
		int		sz;		// used blocks
		int		max;		// allocated number of blocks
		int		block;		// number of bits per block

	public:

			bits(const int i = 96);
			bits(const bits&);
			~bits() { delete [] b; }

		int	operator[](int) const;
		void	operator=(const bits&);
		int	operator==(const bits&) const;
		int	operator<(const bits&) const;
		int	operator>(const bits& b) const;
		bits&	operator+=(const bits&);
		bits&	operator+=(const int&);
		void	clear();
		void	clear(const int v)	// assumes valid index!
			{ b[v / block] &= ~((unsigned int) 1 << (v % block)); }
		void	increase(const int i);	// make bitmap larger
		void	extract(bits&, const int) const;
		int	member(const bits&) const;
		int	next(int index) const;
#ifdef	ATT
		void	Set(const int v)	// assumes valid index! 
#else
		void	set(const int v)	// assumes valid index! 
#endif
			{ b[v / block] |= ((unsigned int) 1 << (v % block)); }
		int	size(void) const 
			{ return sz * block; }
};

#define	BITS_CLASS_DEFINITION
#endif
