//	This code copyright (c) by the Grail project.
//	No commercial use permitted without written consent. 
//	December 1995

#ifndef			FL_CLASS_DEFINITION

template <class Item>
class fl
{
	friend	ostream& operator<<(ostream&, const fl<Item>&);
	friend	istream& operator>>(istream&, fl<Item>&);

	private:

	set<string<Item> >	words;
	
	public:
			fl() { }
			~fl() { }
			fl(const fl<Item>& f)
			{ words = f.words; }
	fl<Item>&	append(const string<Item>& s);
	void		clear() 
			{ words.clear(); }
	void		get_words(set<string<Item> >& s) const
			{ s = words; } 
	fl<Item>&	intersect(const fl<Item>& f1, const fl<Item>& f2)
			{ words.intersect(f1.words, f2.words); return *this; }
	int		member(const string<Item>& s) const 
			{ return words.member(s); }
	int		member_of_language(const string<Item>& s) const 
			{ return words.member(s) != -1; }
	fl<Item>&	left_quotient(const string<Item>&);
	fl<Item>&	prepend(const string<Item>& s);
	fl<Item>&	reverse(); 		
	fl<Item>&	right_quotient(const string<Item>&);
	int		size() const
			{ return words.size(); }
	fl<Item>&	operator=(const fl<Item>& l)
				{ words = l.words; return *this; }
	fl<Item>&	operator=(const set<string<Item> >& s)
				{ words = s; return *this; }
	fl<Item>&	operator=(const string<Item>& s)
				{ words = s; return *this; }
	int		operator==(const fl<Item>& l) const 
				{ return words == l.words; }
	int		operator!=(const fl<Item>& l) const 
				{ return words != l.words; }
	int		operator>(const fl<Item>& x) const
				{ return x.words > words ? 1 : 0; }
	int		operator<(const fl<Item>& x) const
				{ return x.words < words ? 1 : 0; }
	fl<Item>&	operator*=(const fl<Item>& l);
	fl<Item>&	operator+=(string<Item> str) 
				{ words += str; return *this; }
	fl<Item>&	operator+=(fl<Item>& l) 
				{ words += l.words; return *this; }
	fl<Item>&	operator-=(const fl<Item>& l) 
				{ words -= l.words; return *this; }
	fl<Item>&	operator-=(const string<Item>& s) 
				{ words -= s; return *this; }
};

#define		FL_CLASS_DEFINITION
#endif
