//	public definition of inst class
//	This code copyright (c) by the Grail project.
//	No commercial use permitted without written consent. 
//	December 1993

#ifndef		INST_CLASS_DEFINITION

#include	<strstream.h>

template <class Label>
class inst
{
        // friend functions

        friend  istream&
        operator>>(istream&,inst<Label>&);              // stream input

	private:

	state		source;				// source state
	state		sink;				// sink state
	Label		label;				// instruction label

	public:

	// public variables

	static	char	left_delimiter;			// used for output
	static	char	right_delimiter;		// used for output

	// public functions

	public:
			inst() { ; }
			// inst(const state& s1, const Label& r ,const state& s2)
			// { source = s1; label = r; sink = s2; }
			inst(const inst<Label>& t) :
			source(t.source), label(t.label), sink(t.sink) { }
			// ~inst() { ; }	 		
	inst<Label>&	operator=(const inst<Label>& t)
			{ if (this != &t) { source = t.source; 
			  label = t.label; sink = t.sink; } return *this; }
	int		operator==(const inst<Label>& s) const
			{ return source != s.source || sink != s.sink 
				|| label != s.label ? 0 : 1; }
	int		operator!=(const inst<Label>& t) const
			{ return *this == t ? 0 : 1; }
	int		operator<(const inst<Label>&) const;
	int		operator>(const inst<Label>& t) const
			{ return *this < t ? 0 : 1; }
	inst<Label>&	assign(const state& s1, const Label& r, const state& s2)
			{ source = s1; label = r; sink = s2; return *this; }
	Label&		get_label() 
			{ return label; }
	state&		get_sink() 
			{ return sink; }
	state&		get_source()
			{ return source; }
	int		is_start() const
			{ return source.is_start() ? 1 : 0; }
	int		is_final() const
			{ return sink.is_final() ? 1 : 0; }
	int		is_null() const
			{ return source.is_null() ? 1 : 0; }
	int		labelis(const Label& r) const
			{ return is_start() || is_final() || label != r ? 0 : 1; } 
	void		make_final(const state& s)
			{ source = s; sink.final(); }
	void		make_start(const state& s)
			{ sink = s; source.start(); }
	void		renumber(int bottom)
			{
				if (!source.is_start()) source += bottom;
				if (!sink.is_final()) sink += bottom;
			}
	void		reverse()
			{ state st = source; source = sink; sink = st; }
	void		null()
			{ source.null(); }
	int		sinkis(const state& s) const
			{ return sink == s ? 1 : 0; }
	int		sourceis(const state& s) const
			{ return source == s ? 1 : 0; }
};

#define		INST_CLASS_DEFINITION
#endif
