//	This code copyright (c) by the Grail project.
//	No commercial use permitted without written consent. 
//	December 1995

#ifndef		POOL_CLASS_DEFINITION

#define		POOL_SIZE	128

template <class S>
class pool
{
	private:

	array<S*>	p;	// array of pointers to 2^n-sized blocks
	bits		b;	// which elements are in use
	int		sz;	// next element to allocate
	int		sp;	// how sparse we are

	public:
		pool() { p += new S[POOL_SIZE]; b.clear(); sz = sp = 0; }
		pool(const pool<S>& s) : p(s.p), b(s.b), sz(s.sz), sp(s.sp) { }
		~pool() { }
	pool<S>&	operator=(const pool<S>& s) 
			{ p = s.p; b = s.b; sz = s.sz; sp = s.sp;
			  return *this; }
	int	operator==(const pool<S>&) const;
	int	operator!=(const pool<S>& s) const
		{ return *this == s ? 0 : 1; }
	int	operator<(const pool<S>&) const;
	int	operator>(const pool<S>& s) const
		{ if (*this == s) return 0; else if (*this < s) return 0;
		  else return 1; }
	void*	get_member();
	void	return_member(void*);
};

#define	POOL_CLASS_DEFINITION
#endif
