//	public definition of state class	
//	This code copyright (c) by the Grail project.
//	No commercial use permitted without written consent. 
//	December 1993

#ifndef			STATE_CLASS_DEFINITION
#include	<iostream.h>

class state
{
	enum { NULL_STATE = -3, START = 0, FINAL = 1, EITHER = 2 };

	private:

	int		number;				// state number

	// public functions

	public:

	int	is_null() const				// is this state null?
		{ return number == NULL_STATE ? 1 : 0; }
	int	is_final() const			// is this a final?
		{ return number == FINAL ? 1 : 0; } 
	int	is_start() const			// is this a start?
		{ return number == START ? 1 : 0; } 
	void	null()					// make state null
		{ number = NULL_STATE; }
		state()	: number(NULL_STATE) { }
		state(const state& s) : number(s.number) { }
		state(const int& i) : number(i + 2) { }
	state&	operator=(const state& s)
		{ number = s.number; return *this; }
	state&	operator=(const int& i)
		{ number = i + 2; return *this; }
	int	operator==(const state& s) const
		{ return number == s.number ? 1 : 0; } 
	int	operator!=(const state& s) const
		{ return number != s.number ? 1 : 0; } 
	void	operator+=(const state& s)
		{ number += s.number; }
	void	operator+=(int i)	
		{ number += i; }
	void	operator-=(const state& s);	
	void	operator-=(int i);		
	int	operator<(const state& s) const		// < comparison
		{ return number < s.number ? 1 : 0; }
	int	operator<(int i) const			// < comparison
		{ return number < (i + 2) ? 1 : 0; }
	int	operator>(const state& s) const		// > comparison
		{ return number > s.number ? 1 : 0; }
	int	operator>(int i) const 			// > comparison
		{ return number > (i + 2) ? 1 : 0; }
	void	final()					// make a final state
		{ number = FINAL; }
	void	start()					// make a start state
		{ number = START; }
		//~state()	 			// destruction
		//{ ; }	
	int	value() const				// return value
		{ return number-2; }
};

#define STATE_CLASS_DEFINITION
#endif
